"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var file_icons_1 = require("./file-icons/file-icons");
var FileItem_1 = __importDefault(require("./FileItem"));
var utils_1 = require("./utils");
function getClass(fileName, isDirectory, expanded) {
    var className = "";
    if (isDirectory) {
        className = expanded ? "folder-icon-open" : "folder-icon";
        className += " light-folder-color";
    }
    else {
        var icon = file_icons_1.db.matchName(fileName, false);
        className = (0, file_icons_1.getClassWithColor)(fileName, icon);
        if (!className) {
            className = "file-icon light-blue";
        }
    }
    return className;
}
function FileItemWithFileIcon(_a) {
    var treeNode = _a.treeNode;
    var filename = (0, utils_1.getFileName)(treeNode.uri);
    var iconClass = getClass(filename, treeNode.type === "directory", treeNode.expanded);
    return (react_1.default.createElement(FileItem_1.default, { icon: react_1.default.createElement("span", { className: iconClass }), filename: filename }));
}
exports.default = FileItemWithFileIcon;
