import React from "react";
import { List } from "react-virtualized";
import { TreeItemProps } from "./TreeItem";
import { TreeNode } from "./type";
export interface FileTreeProps {
    /**
     * 是否支持拖拽
     */
    draggable?: boolean;
    tree?: TreeNode;
    /**
     * 点击条目
     */
    onItemClick?: (treeNode: TreeNode) => void;
    /**
     * 拖拽
     * @param fromUri
     * @param toDirUri
     */
    onDrop?: TreeItemProps["onDrop"];
    onDragOver?: TreeItemProps["onDragOver"];
    sorter?: (treeNodes: TreeNode[]) => TreeNode[];
    /**
     * 无数据时展示
     */
    emptyRenderer?: () => React.ReactElement;
    /**
     * 右键回调
     */
    onContextMenu?: (event: React.MouseEvent<HTMLDivElement>, treeNode: TreeNode) => void;
    /**
     * 渲染节点
     */
    itemRenderer?: (treeNode: TreeNode) => React.ReactNode;
    /**
     * 子节点缩进尺寸
     */
    indent?: number;
    /**
     *  节点高度，默认30
     */
    rowHeight?: number;
    /**
     * 缩进单位，默认px
     */
    indentUnit?: string;
}
export declare const FileTree: React.ForwardRefExoticComponent<FileTreeProps & React.RefAttributes<List>>;
