"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileTree = void 0;
var react_1 = __importStar(require("react"));
var react_virtualized_1 = require("react-virtualized");
var FileItem_1 = __importDefault(require("./FileItem"));
var TreeItem_1 = require("./TreeItem");
var utils_1 = require("./utils");
function defaultEmptyRenderer() {
    return react_1.default.createElement("div", { className: "file-tree__empty" }, "Nothing");
}
function defaultItemRenderer(treeNode) {
    var emoji = treeNode.type === "directory" ? (treeNode.expanded ? "📂" : "📁") : "🗎";
    return react_1.default.createElement(FileItem_1.default, { icon: emoji, filename: (0, utils_1.getFileName)(treeNode.uri) });
}
exports.FileTree = (0, react_1.forwardRef)(function (_a, ref) {
    var tree = _a.tree, draggable = _a.draggable, indent = _a.indent, rowHeight = _a.rowHeight, indentUnit = _a.indentUnit, onContextMenu = _a.onContextMenu, onItemClick = _a.onItemClick, onDrop = _a.onDrop, onDragOver = _a.onDragOver, emptyRenderer = _a.emptyRenderer, itemRenderer = _a.itemRenderer, sorter = _a.sorter;
    var items = (0, utils_1.flatTreeData)(tree ? [tree] : [], sorter);
    var itemRender = itemRenderer
        ? function (treeNode) { return itemRenderer === null || itemRenderer === void 0 ? void 0 : itemRenderer(treeNode); }
        : defaultItemRenderer;
    var rowRenderer = function (params) {
        var treeNode = items[params.index];
        var indentNum = indent || 10;
        return (react_1.default.createElement(TreeItem_1.TreeItem, { draggable: draggable, key: treeNode.uri, indentUnit: indentUnit || "px", indent: indentNum * (0, utils_1.calcLevel)(treeNode.uri, (tree === null || tree === void 0 ? void 0 : tree.uri) || ""), style: params.style, treeNode: treeNode, onContextMenu: onContextMenu, treeItemRenderer: itemRender, onClick: onItemClick, onDragOver: onDragOver, onDrop: onDrop }));
    };
    return (react_1.default.createElement(react_virtualized_1.AutoSizer, null, function (_a) {
        var height = _a.height, width = _a.width;
        return (react_1.default.createElement(react_virtualized_1.List, { ref: ref, className: "file-tree", height: height, width: width, overscanRowCount: 30, noRowsRenderer: emptyRenderer || defaultEmptyRenderer, rowCount: items.length, rowHeight: rowHeight || 30, rowRenderer: rowRenderer }));
    }));
});
